function compList = getCalibrationComponentNames(this)
%GETCALIBRATIONCOMPONENTNAMES returns the list of Parameter-Software-Component-Type
%    names found in the XML files associated with the arxml.importer object.
%   COMPONENTNAMES = GETCALIBRATIONCOMPONENTNAMES(IMPORTER) returns the list of 
%   Parameter-Software-Component-Type names COMPONENTNAMES found in the XML 
%   files associated with the arxml.importer object IMPORTER.
%
%   COMPONENTNAMES is a cell array of strings in which each element is the
%   absolute Short-Name path of the corresponding component: 
%   '/root_package_name[/sub_package_name]/component_short_name'.

%   Copyright 2008-2017 The MathWorks, Inc.

try
    compList = p_getcomponentnames(this, 'Parameter');
catch Me
    %Trim stack to remove internal functions
    autosar.mm.util.MessageReporter.throwException(Me);
end
% LocalWords:  COMPONENTNAMES
