function setFile(this, aFilename)
%SETFILE sets the XML file name associated with the arxml.importer object.
%   SETFILE(IMPORTER, FILENAME) sets the XML file name FILENAME associated
%   with the arxml.importer object IMPORTER.
%
%   Note:
%      Only the Atomic-Software-Components described in this XML file 
%      can be imported. 

%   Copyright 2007-2017 The MathWorks, Inc.

if ischar(aFilename) || isStringScalar(aFilename)
    p_setfile(this, aFilename);

else
   autosar.mm.util.MessageReporter.createWarning('RTW:autosar:badFilename');
end
