classdef MemoryServiceComponent < handle
% Class to define a Memory Service Component

%   Copyright 2017 The MathWorks, Inc.
    
    methods(Static, Access=public)

        function desc = getDescription()
            desc = 'Configure AUTOSAR Memory Services and Runtime Environment (RTE) for emulation.';
        end
        
        function type = getType()
            type = 'Memory Service Component';
        end

        function blockIconType = getBlockIconType()
            blockIconType = '';
        end
        
        function display = getDisplay()
           display = 'disp(''Memory Service\n   Component'')'; 
        end
        
        function help = getHelp()
            help = 'helpview(fullfile(docroot,''ecoder'',''helptargets.map''),''autosar_memory_service_block'');';
        end
        
        
        function addBlocks(blkPath)

            % NVM reference implementation
            add_block('autosarspkglib_internal/autosar_nvm', [blkPath, '/NvM'], ... 
                'Position', [255 168 397 213]);

        end
        
        function addMaskObjectParameters(~)
        end
        
    end
    
end

% LocalWords:  helptargets NVM Nv nvm autosarspkglib
