classdef mappingCategories < handle
    % MAPPING CATEGORIES provides the legal categories for the different
    % mapping items. 
    % For example: The valid mapping categories for data defaults are LocalParameters,
    % ParameterArguments, and Internal Data. 
    %

%   Copyright 2018 The MathWorks, Inc.

    methods(Static, Access = public)
        function categories = getDataCategoriesForDataDefaults()
            categories = {};
            if slfeature('CodeInterfaceCustomization') >= 4
                 categories =  {
                    'LocalParameters',...
                    'ParameterArguments',...
                    'InternalData'};       
            end
        end
        
        function categories = getMappedToCategoriesForInternalData()
            categories = {
                'Default',...
                'ArTypedPerInstanceMemory',...
                'StaticMemory',...
                'StorageClass'};
        end
        
        function categories = getMappedToCategoriesForParameters()
            categories = {
                'Default',...
                'SharedParameters',...
                'PerInstanceParameter',...
                'StorageClass',...
                };
        end
    end
end
