function out = changeInitValue(block, valueStr)
% CHANGEINITVALUE
% BLOCK -- Name of block to change access mode
% valueStr -- new InitValue string

%   Copyright 2017-2018 The MathWorks, Inc.

modelName = bdroot(block);

slmapping = autosar.api.getSimulinkMapping(modelName);
blockType = get_param(block, 'BlockType');
isInport = strcmp(blockType, 'Inport');

index = strfind(block, '/');
blockName = block(index(end)+1:end);

if isInport
    [ARPortName, ARDataElementName, ~] = slmapping.getInport(blockName);
else
    [ARPortName, ARDataElementName, ~] = slmapping.getOutport(blockName);
end

m3iComp = autosar.api.Utils.m3iMappedComponent(modelName);

% find m3iPort
m3iPort = autosar.ui.comspec.ComSpecUtils.findM3IPortByName(m3iComp, ARPortName);
assert(~isempty(m3iPort), 'm3iPort not found');
% find m3iInfo
m3iInfo = autosar.ui.comspec.ComSpecUtils.findM3IPortInfoForDataElement(m3iPort, ...
    ARDataElementName, isInport);
assert(~isempty(m3iInfo), 'm3iPort not found');

% set InitValue to new value
autosar.ui.comspec.ComSpecPropertyHandler.setComSpecPropertyValue(...
    m3iInfo.comSpec, 'InitValue', valueStr);

out = 'InitValue Changed';

